Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonVRD.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonVRD.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonVRD.pm	(revision 34921)
@@ -867,14 +882,591 @@
         },
     },
-    # (VRD 3.8 edit data ends here: 286 bytes, index 0x8f)
+    # (VRD 3.8.0 edit data ends here: 286 bytes, index 0x8f)
     0x90 => {
         Name => 'UnsharpMask',
         PrintConv => { 0 => 'Off', 1 => 'On' },
     },
-    0x92 => 'UnsharpMaskStrength',
-    0x94 => 'UnsharpMaskFineness',
-    0x96 => 'UnsharpMaskThreshold',
-    # (VRD 3.91 edit data ends here: 392 bytes, index 0xc4)
+    0x92 => 'StandardUnsharpMaskStrength',
+    0x94 => 'StandardUnsharpMaskFineness',
+    0x96 => 'StandardUnsharpMaskThreshold',
+    0x98 => 'PortraitUnsharpMaskStrength',
+    0x9a => 'PortraitUnsharpMaskFineness',
+    0x9c => 'PortraitUnsharpMaskThreshold',
+    0x9e => 'LandscapeUnsharpMaskStrength',
+    0xa0 => 'LandscapeUnsharpMaskFineness',
+    0xa2 => 'LandscapeUnsharpMaskThreshold',
+    0xa4 => 'NeutraUnsharpMaskStrength',
+    0xa6 => 'NeutralUnsharpMaskFineness',
+    0xa8 => 'NeutralUnsharpMaskThreshold',
+    0xaa => 'FaithfulUnsharpMaskStrength',
+    0xac => 'FaithfulUnsharpMaskFineness',
+    0xae => 'FaithfulUnsharpMaskThreshold',
+    0xb0 => 'MonochromeUnsharpMaskStrength',
+    0xb2 => 'MonochromeUnsharpMaskFineness',
+    0xb4 => 'MonochromeUnsharpMaskThreshold',
+    0xb6 => 'CustomUnsharpMaskStrength',
+    0xb8 => 'CustomUnsharpMaskFineness',
+    0xba => 'CustomUnsharpMaskThreshold',
+    0xbc => 'CustomDefaultUnsharpStrength',
+    0xbe => 'CustomDefaultUnsharpFineness',
+    0xc0 => 'CustomDefaultUnsharpThreshold',
+    # (VRD 3.9.1 edit data ends here: 392 bytes, index 0xc4)
+    # 0xc9: 3    - some RawSharpness
+    # 0xca: 4095 - some RawHighlightPoint
+    # 0xcb: 0    - some RawShadowPoint
+    # 0xcc: 4095 - some OutputHighlightPoint
+    # 0xcd: 0    - some OutputShadowPoint
+    # 0xd1: 3    - some UnsharpMaskStrength
+    # 0xd3: 7    - some UnsharpMaskFineness
+    # 0xd5: 3,4  - some UnsharpMaskThreshold
+    0xd6 => { Name => 'CropCircleActive', %noYes },
+    0xd7 => 'CropCircleX',
+    0xd8 => 'CropCircleY',
+    0xd9 => 'CropCircleRadius',
+    # 0xda: 0, 1
+    # 0xdb: 100
+    0xdc => {
+        Name => 'DLOOn',
+        DataMember => 'DLOOn',
+        RawConv => '$$self{DLOOn} = $val',
+        %noYes,
+    },
+    0xdd => 'DLOSetting',
+    # (VRD 3.11.0 edit data ends here: 444 bytes, index 0xde)
+    0xde => {
+        Name => 'DLOShootingDistance',
+        Notes => '100% = infinity',
+        RawConv => '$val == 0x7fff ? undef : $val',
+        ValueConv => '1 - $val / 0x400',
+        ValueConvInv => 'int((1 - $val) * 0x400 + 0.5)',
+        PrintConv => 'sprintf("%.0f%%", $val * 100)',
+        PrintConvInv => 'ToFloat($val) / 100',
+    },
+    0xdf => {
+        Name => 'DLODataLength',
+        DataMember => 'DLODataLength',
+        Format => 'int32u',
+        Writable => 0,
+        RawConv => '$$self{DLODataLength} = $val',
+    },
+    0xe0 => { # (yes, this overlaps DLODataLength)
+        Name => 'DLOInfo',
+        # - have seen DLODataLengths of 65536,64869 when DLO is Off, so must test DLOOn flag
+        Condition => '$$self{DLOOn}',
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::DLOInfo' },
+        Hook => '$varSize += $$self{DLODataLength} + 0x16',
+    },
+    0xe1 => 'CameraRawColorTone',
+    # (VRD 3.11.2 edit data ends here: 452 bytes, index 0xe2, unless DLO is on)
+    0xe2 => 'CameraRawSaturation',
+    0xe3 => 'CameraRawContrast',
+    0xe4 => { Name => 'CameraRawLinear', %noYes },
+    0xe5 => 'CameraRawSharpness',
+    0xe6 => 'CameraRawHighlightPoint',
+    0xe7 => 'CameraRawShadowPoint',
+    0xe8 => 'CameraRawOutputHighlightPoint',
+    0xe9 => 'CameraRawOutputShadowPoint',
 );
+
+# DLO tags (ref PH)
+%Image::ExifTool::CanonVRD::DLOInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FIRST_ENTRY => 1,
+    FORMAT => 'int16s',
+    GROUPS => { 2 => 'Image' },
+    NOTES => 'Tags added when DLO (Digital Lens Optimizer) is on.',
+    # 0x01 - seen 3112,3140
+    0x04 => 'DLOSettingApplied',
+    0x05 => {
+        Name => 'DLOVersion', #(NC)
+        Format => 'string[10]',
+    },
+    0x0a => {
+        Name => 'DLOData',
+        LargeTag => 1, # large tag, so avoid storing unnecessarily
+        Notes => 'variable-length Digital Lens Optimizer data, stored in JPEG-like format',
+        Format => 'undef[$$self{DLODataLength}]',
+        Writable => 0,
+        Binary => 1,
+    },
+);
+
+# VRD version 4 tags (ref PH)
+%Image::ExifTool::CanonVRD::DR4 = (
+    PROCESS_PROC => \&ProcessDR4,
+    WRITE_PROC => \&ProcessDR4,
+    WRITABLE => 1,
+    GROUPS => { 2 => 'Image' },
+    VARS => { HEX_ID => 1, SORT_PROC => \&SortDR4 },
+    NOTES => q{
+        Tags written by Canon DPP version 4 in CanonVRD trailers and DR4 files. Each
+        tag has three associated flag words which are stored with the directory
+        entry, some of which are extracted as a separate tag, indicated in the table
+        below by a decimal appended to the tag ID (.0, .1 or .2).
+    },
+    header => {
+        Name => 'DR4Header',
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::DR4Header' },
+    },
+    0x10002 => 'Rotation', # left/right rotation 90,180,270
+    0x10003 => 'AngleAdj', # crop angle
+    # 0x10018 - fmt=8: 0
+    # 0x10020 - fmt=2: ''
+    0x10021 => 'CustomPictureStyle', # (string)
+    0x10101 => {
+        Name => 'CheckMark',
+        PrintConv => {
+            0 => 'Clear',
+            1 => 1,
+            2 => 2,
+            3 => 3,
+            4 => 4,
+            5 => 5,
+        },
+    },
+    0x10200 => {
+        Name => 'WorkColorSpace',
+        PrintConv => {
+            1 => 'sRGB',
+            2 => 'Adobe RGB',
+            3 => 'Wide Gamut RGB',
+            4 => 'Apple RGB',
+            5 => 'ColorMatch RGB',
+        },
+    },
+    # 0x10201 - fmt=9: 0
+    # 0x10f20 - fmt=9: 350
+    0x20001 => 'RawBrightnessAdj',
+    0x20101 => {
+        Name => 'WhiteBalanceAdj',
+        PrintConvColumns => 2,
+        PrintConv => {
+            -1 => 'Manual (Click)',
+            0 => 'Auto',
+            1 => 'Daylight',
+            2 => 'Cloudy',
+            3 => 'Tungsten',
+            4 => 'Fluorescent',
+            5 => 'Flash',
+            8 => 'Shade',
+            9 => 'Kelvin',
+            255 => 'Shot Settings',
+        },
+    },
+    0x20102 => 'WBAdjColorTemp',
+    0x20105 => 'WBAdjMagentaGreen',
+    0x20106 => 'WBAdjBlueAmber',
+    0x20125 => {
+        Name => 'WBAdjRGGBLevels',
+        PrintConv => '$val =~ s/^\d+ //; $val',  # remove first integer (14: what is this for?)
+        PrintConvInv => '"14 $val"',
+    },
+    0x20200 => { Name => 'GammaLinear', %noYes },
+    0x20301 => {
+        Name => 'PictureStyle',
+        PrintHex => 1,
+        PrintConv => {
+            0x81 => 'Standard',
+            0x82 => 'Portrait',
+            0x83 => 'Landscape',
+            0x84 => 'Neutral',
+            0x85 => 'Faithful',
+            0x86 => 'Monochrome',
+            0x87 => 'Auto',
+            0x88 => 'Fine Detail',
+            0xf0 => 'Shot Settings',
+            0xff => 'Custom',
+        },
+    },
+    # 0x20302 - Gamma curve data
+    0x20303 => 'ContrastAdj',
+    0x20304 => 'ColorToneAdj',
+    0x20305 => 'ColorSaturationAdj',
+    0x20306 => {
+        Name => 'MonochromeToningEffect',
+        PrintConv => {
+            0 => 'None',
+            1 => 'Sepia',
+            2 => 'Blue',
+            3 => 'Purple',
+            4 => 'Green',
+        },
+    },
+    0x20307 => {
+        Name => 'MonochromeFilterEffect',
+        PrintConv => {
+            0 => 'None',
+            1 => 'Yellow',
+            2 => 'Orange',
+            3 => 'Red',
+            4 => 'Green',
+        },
+    },
+    0x20308 => 'UnsharpMaskStrength',
+    0x20309 => 'UnsharpMaskFineness',
+    0x2030a => 'UnsharpMaskThreshold',
+    0x2030b => 'ShadowAdj',
+    0x2030c => 'HighlightAdj',
+    0x20310 => {
+        Name => 'SharpnessAdj',
+        PrintConv => {
+            0 => 'Sharpness',
+            1 => 'Unsharp Mask',
+        },
+    },
+   '0x20310.0' => { Name => 'SharpnessAdjOn', %noYes },
+    0x20311 => 'SharpnessStrength',
+    0x20400 => {
+        Name => 'ToneCurve',
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::ToneCurve' },
+    },
+   '0x20400.1' => { Name => 'ToneCurveOriginal', %noYes },
+    # 0x20401 - fmt=33 (312 bytes)
+    0x20410 => 'ToneCurveBrightness',
+    0x20411 => 'ToneCurveContrast',
+    0x20500 => {
+        Name => 'AutoLightingOptimizer',
+        PrintConv => {
+            0 => 'Low',
+            1 => 'Standard',
+            2 => 'Strong',
+        },
+    },
+   '0x20500.0' => {
+        Name => 'AutoLightingOptimizerOn',
+        Notes => 'ignored if gamma is linear',
+        %noYes,
+    },
+    # 0x20501 - fmt=13: 0
+    # 0x20502 - fmt=13: 0
+    0x20600 => 'LuminanceNoiseReduction',
+    0x20601 => 'ChrominanceNoiseReduction',
+    # 0x20650 - fmt=9: 0 (JPG images)
+    0x20670 => 'ColorMoireReduction',
+   '0x20670.0' => { Name => 'ColorMoireReductionOn', %noYes },
+    0x20701 => {
+        Name => 'ShootingDistance',
+        Notes => '100% = infinity',
+        ValueConv => '$val / 10',
+        ValueConvInv => '$val * 10',
+        PrintConv => 'sprintf("%.0f%%", $val * 100)',
+        PrintConvInv => 'ToFloat($val) / 100',
+    },
+    0x20702 => {
+        Name => 'PeripheralIllumination',
+        PrintConv => 'sprintf "%g", $val',
+        PrintConvInv => '$val',
+    },
+   '0x20702.0' => { Name => 'PeripheralIlluminationOn', %noYes },
+    0x20703 => {
+        Name => 'ChromaticAberration',
+        PrintConv => 'sprintf "%g", $val',
+        PrintConvInv => '$val',
+    },
+   '0x20703.0' => { Name => 'ChromaticAberrationOn', %noYes },
+    0x20704 => { Name => 'ColorBlurOn', %noYes },
+    0x20705 => {
+        Name => 'DistortionCorrection',
+        PrintConv => 'sprintf "%g", $val',
+        PrintConvInv => '$val',
+    },
+   '0x20705.0' => { Name => 'DistortionCorrectionOn', %noYes },
+    0x20706 => 'DLOSetting',
+   '0x20706.0' => { Name => 'DLOOn', %noYes },
+    0x20707 => {
+        Name => 'ChromaticAberrationRed',
+        PrintConv => 'sprintf "%g", $val',
+        PrintConvInv => '$val',
+    },
+    0x20708 => {
+        Name => 'ChromaticAberrationBlue',
+        PrintConv => 'sprintf "%g", $val',
+        PrintConvInv => '$val',
+    },
+    0x20709 => {
+        Name => 'DistortionEffect',
+        PrintConv => {
+            0 => 'Shot Settings',
+            1 => 'Emphasize Linearity',
+            2 => 'Emphasize Distance',
+            3 => 'Emphasize Periphery',
+            4 => 'Emphasize Center',
+        },
+    },
+    # 0x20800 - fmt=1: 0
+    # 0x20801 - fmt=1: 0
+    0x2070b => { Name => 'DiffractionCorrectionOn', %noYes },
+    0x20900 => 'ColorHue',
+    0x20901 => 'SaturationAdj',
+    0x20910 => 'RedHSL',
+    0x20911 => 'OrangeHSL',
+    0x20912 => 'YellowHSL',
+    0x20913 => 'GreenHSL',
+    0x20914 => 'AquaHSL',
+    0x20915 => 'BlueHSL',
+    0x20916 => 'PurpleHSL',
+    0x20917 => 'MagentaHSL',
+    0x20a00 => {
+        Name => 'GammaInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::GammaInfo' },
+    },
+    # 0x20a01 - Auto picture style settings
+    # 0x20a02 - Standard picture style settings
+    # 0x20a03 - Portrait picture style settings
+    # 0x20a04 - Landscape picture style settings
+    # 0x20a05 - Neutral picture style settings
+    # 0x20a06 - Faithful picture style settings
+    # 0x20a07 - Monochrome picture style settings
+    # 0x20a08 - (unknown picture style settings)
+    # 0x20a09 - Custom picture style settings
+    # 0x20a20 - Fine Detail picture style settings
+    0x30101 => {
+        Name => 'CropAspectRatio',
+        PrintConv => {
+            0 => 'Free',
+            1 => 'Custom',
+            2 => '1:1',
+            3 => '3:2',
+            4 => '2:3',
+            5 => '4:3',
+            6 => '3:4',
+            7 => '5:4',
+            8 => '4:5',
+            9 => '16:9',
+            10 => '9:16',
+        },
+    },
+    0x30102 => 'CropAspectRatioCustom',
+    # 0x30103 - fmt=33: "0 0 8"
+    0xf0100 => {
+        Name => 'CropInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::CropInfo' },
+    },
+    0xf0500 => {
+        Name => 'CustomPictureStyleData',
+        Binary => 1,
+    },
+    0xf0510 => {
+        Name => 'StampInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::StampInfo' },
+    },
+    0xf0511 => {
+        Name => 'DustInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::DustInfo' },
+    },
+    0xf0512 => 'LensFocalLength',
+    # 0xf0521 - DLO data
+    # 0xf0520 - DLO data
+    # 0xf0530 - created when dust delete data applied (4 bytes, all zero)
+    # 0xf0600 - fmt=253 (2308 bytes, JPG images)
+    # 0xf0601 - fmt=253 (2308 bytes, JPG images)
+    # 0x1ff52c - values: 129,130,132 (related to custom picture style somehow)
+    # to do:
+    # - find 8-15mm CR2 sample and decode linear distortion effect fine-tune
+);
+
+# Version 4 header information (ref PH)
+%Image::ExifTool::CanonVRD::DR4Header = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    FORMAT => 'int32u',
+    GROUPS => { 2 => 'Image' },
+    # 0 - value: 'IIII' (presumably byte order)
+    # 1 - value: 0x00040004 (currently use this for magic number)
+    # 2 - value: 6
+    3 => {
+        Name => 'DR4CameraModel',
+        Writable => 'int32u',
+        PrintHex => 1,
+        SeparateTable => 'Canon CanonModelID',
+        PrintConv => \%Image::ExifTool::Canon::canonModelID,
+    },
+    # 4 - value: 3
+    # 5 - value: 4
+    # 6 - value: 5
+    # 7 - DR4 directory entry count
+);
+
+# Version 4 RGB tone curve information (ref PH)
+%Image::ExifTool::CanonVRD::ToneCurve = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    FORMAT => 'int32u',
+    GROUPS => { 2 => 'Image' },
+    0x00 => {
+        Name => 'ToneCurveColorSpace',
+        PrintConv => {
+            0 => 'RGB',
+            1 => 'Luminance',
+        },
+    },
+    0x01 => {
+        Name => 'ToneCurveShape',
+        PrintConv => {
+            0 => 'Curve',
+            1 => 'Straight',
+        },
+    },
+    0x03 => { Name => 'ToneCurveInputRange',  Format => 'int32u[2]', Notes => '255 max' },
+    0x05 => { Name => 'ToneCurveOutputRange', Format => 'int32u[2]', Notes => '255 max' },
+    0x07 => {
+        Name => 'RGBCurvePoints',
+        Format => 'int32u[21]',
+        PrintConv => 'Image::ExifTool::CanonVRD::ToneCurvePrint($val)',
+        PrintConvInv => 'Image::ExifTool::CanonVRD::ToneCurvePrintInv($val)',
+    },
+    0x0a => 'ToneCurveX',
+    0x0b => 'ToneCurveY',
+    0x2d => {
+        Name => 'RedCurvePoints',
+        Format => 'int32u[21]',
+        PrintConv => 'Image::ExifTool::CanonVRD::ToneCurvePrint($val)',
+        PrintConvInv => 'Image::ExifTool::CanonVRD::ToneCurvePrintInv($val)',
+    },
+    0x53 => {
+        Name => 'GreenCurvePoints',
+        Format => 'int32u[21]',
+        PrintConv => 'Image::ExifTool::CanonVRD::ToneCurvePrint($val)',
+        PrintConvInv => 'Image::ExifTool::CanonVRD::ToneCurvePrintInv($val)',
+    },
+    0x79 => {
+        Name => 'BlueCurvePoints',
+        Format => 'int32u[21]',
+        PrintConv => 'Image::ExifTool::CanonVRD::ToneCurvePrint($val)',
+        PrintConvInv => 'Image::ExifTool::CanonVRD::ToneCurvePrintInv($val)',
+    },
+);
+
+# Version 4 gamma curve information (ref PH)
+%Image::ExifTool::CanonVRD::GammaInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    FORMAT => 'double',
+    GROUPS => { 2 => 'Image' },
+    0x02 => 'GammaContrast',
+    0x03 => 'GammaColorTone',
+    0x04 => 'GammaSaturation',
+    0x05 => 'GammaUnsharpMaskStrength',
+    0x06 => 'GammaUnsharpMaskFineness',
+    0x07 => 'GammaUnsharpMaskThreshold',
+    0x08 => 'GammaSharpnessStrength',
+    0x09 => 'GammaShadow',
+    0x0a => 'GammaHighlight',
+    # 0x0b-0x10 are the same as first 6 doubles of tag DR4_0x20302
+    # 0x0b - value: 14
+    0x0c => {
+        Name => 'GammaBlackPoint',
+        ValueConv => q{
+            return 0 if $val <= 0;
+            $val = log($val / 4.6875) / log(2) + 1;
+            return abs($val) > 1e-10 ? $val : 0;
+        },
+        ValueConvInv => '$val ? exp(($val - 1) * log(2)) * 4.6876 : 0',
+        PrintConv => 'sprintf("%+.3f", $val)',
+        PrintConvInv => '$val',
+    },
+    0x0d => {
+        Name => 'GammaWhitePoint',
+        ValueConv => q{
+            return $val if $val <= 0;
+            $val = log($val / 4.6875) / log(2) - 11.77109325169954;
+            return abs($val) > 1e-10 ? $val : 0;
+        },
+        ValueConvInv => '$val ? exp(($val + 11.77109325169954) * log(2)) * 4.6875 : 0',
+        PrintConv => 'sprintf("%+.3f", $val)',
+        PrintConvInv => '$val',
+    },
+    0x0e => {
+        Name => 'GammaMidPoint',
+        ValueConv => q{
+            return $val if $val <= 0;
+            $val = log($val / 4.6875) / log(2) - 8;
+            return abs($val) > 1e-10 ? $val : 0;
+        },
+        ValueConvInv => '$val ? exp(($val + 8) * log(2)) * 4.6876 : 0',
+        PrintConv => 'sprintf("%+.3f", $val)',
+        PrintConvInv => '$val',
+    },
+    0x0f => { Name => 'GammaCurveOutputRange', Format => 'double[2]', Notes => '16383 max' },
+);
+
+# Version 4 crop information (ref PH)
+%Image::ExifTool::CanonVRD::CropInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    FORMAT => 'int32s',
+    GROUPS => { 2 => 'Image' },
+    0 => { Name => 'CropActive', %noYes },
+    1 => 'CropRotatedOriginalWidth',
+    2 => 'CropRotatedOriginalHeight',
+    3 => 'CropX',
+    4 => 'CropY',
+    5 => 'CropWidth',
+    6 => 'CropHeight',
+    8 => {
+        Name => 'CropRotation',
+        Format => 'double',
+        PrintConv => 'sprintf("%.7g",$val)',
+        PrintConvInv => '$val',
+    },
+    0x0a => 'CropOriginalWidth',
+    0x0b => 'CropOriginalHeight',
+    # 0x0c double - value: 100
+);
+
+# DR4 Stamp Tool tags (ref PH)
+%Image::ExifTool::CanonVRD::StampInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 2 => 'Image' },
+    FORMAT => 'int32u',
+    FIRST_ENTRY => 0,
+    0x02 => 'StampToolCount',
+);
+
+# DR4 dust delete information (ref PH)
+%Image::ExifTool::CanonVRD::DustInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 2 => 'Image' },
+    FORMAT => 'int32u',
+    FIRST_ENTRY => 0,
+    0x02 => { Name => 'DustDeleteApplied', %noYes },
+);
+
+#------------------------------------------------------------------------------
+# sort DR4 tag ID's for the documentation
+sub SortDR4($$)
+{
+    my ($a, $b) = @_;
+    my ($aHex, $aDec, $bHex, $bDec);
+    ($aHex, $aDec) = ($1, $2) if $a =~ /^(0x[0-9a-f]+)?\.?(\d*?)$/;
+    ($bHex, $bDec) = ($1, $2) if $b =~ /^(0x[0-9a-f]+)?\.?(\d*?)$/;
+    if ($aHex) {
+        return 1 unless defined $bDec;  # $b is 'header';
+        return hex($aHex) <=> hex($bHex) || $aDec <=> $bDec if $bHex;
+        return hex($aHex) <=> $bDec || 1;
+    } elsif ($bHex) {
+        return -1 unless defined $aDec;
+        return $aDec <=> hex($bHex) || -1;
+    } else {
+        return 1 unless defined $bDec;
+        return -1 unless defined $aDec;
+        return $aDec <=> $bDec;
+    }
+}
 
 #------------------------------------------------------------------------------
@@ -913,6 +1505,6 @@
 sub ProcessEditData($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access
     my $dataPt = $$dirInfo{DataPt};
     my $pos = $$dirInfo{DirStart};
@@ -920,10 +1512,18 @@
     my $outfile = $$dirInfo{OutFile};
     my $dirLen = $$dirInfo{DirLen};
+    my $verbose = $et->Options('Verbose');
+    my $out = $et->Options('TextOut');
+    my $oldChanged = $$et{CHANGED};
+
+    $et->VerboseDir('VRD Edit Data', 0, $dirLen) unless $outfile;
+
+    if ($outfile) {
+        # make a copy for editing in place
+        my $buff = substr($$dataPt, $pos, $dirLen);
+        $dataPt = $$dirInfo{DataPt} = \$buff;
+        $dataPos += $pos;
+        $pos = $$dirInfo{DirStart} = 0;
+    }
     my $dirEnd = $pos + $dirLen;
-    my $verbose = $exifTool->Options('Verbose');
-    my $out = $exifTool->Options('TextOut');
-    my $oldChanged = $$exifTool{CHANGED};
-
-    $exifTool->VerboseDir('VRD Edit Data', 0, $dirLen);
 
     # loop through all records in the edit data
@@ -935,14 +1535,18 @@
         } else {
             $recLen = Get32u($dataPt, $pos);
+            # (DR4 has a null terminator)
+            last if $recLen == 0 and $pos + 4 == $dirEnd;
         }
         $pos += 4;          # move to start of record
         if ($pos + $recLen > $dirEnd) {
-            $exifTool->Warn('Possibly corrupt CanonVRD Edit record');
+            $et->Warn('Possibly corrupt CanonVRD Edit record');
             $err = 1;
             last;
         }
+        my $saveRecLen = $recLen;
         if ($verbose > 1 and not $outfile) {
-            printf $out "$$exifTool{INDENT}CanonVRD Edit record ($recLen bytes at offset 0x%x)\n",
+            printf $out "$$et{INDENT}CanonVRD Edit record ($recLen bytes at offset 0x%x)\n",
                    $pos + $dataPos;
+            $et->VerboseDump($dataPt, Len => $recLen, Start => $pos, Addr => $pos + $dataPos) if $recNum;
         }
 
@@ -951,56 +1555,71 @@
 
         # process VRD edit information
-        my $subTablePtr = GetTagTable('Image::ExifTool::CanonVRD::Edit');
+        my $subTablePtr = $tagTablePtr;
         my $index;
-        my $editData = substr($$dataPt, $pos, $recLen);
         my %subdirInfo = (
-            DataPt => \$editData,
-            DataPos => $dataPos + $pos,
+            DataPt   => $dataPt,
+            DataPos  => $dataPos,
+            DirStart => $pos,
+            DirLen   => $recLen,
+            OutFile  => $outfile,
         );
-        my $start = 0;
+        my $subStart = 0;
         # loop through various sections of the VRD edit data
         for ($index=0; ; ++$index) {
             my $tagInfo = $$subTablePtr{$index} or last;
-            my $dirLen;
-            my $maxLen = $recLen - $start;
+            my $subLen;
+            my $maxLen = $recLen - $subStart;
             if ($$tagInfo{Size}) {
-                $dirLen = $$tagInfo{Size};
+                $subLen = $$tagInfo{Size};
             } elsif (defined $$tagInfo{Size}) {
-                # get size from int32u at $start
-                last unless $start + 4 <= $recLen;
-                $dirLen = Get32u(\$editData, $start);
-                $start += 4; # skip the length word
+                # get size from int32u at $subStart
+                last unless $subStart + 4 <= $recLen;
+                $subLen = Get32u($dataPt, $subStart + $pos);
+                $subStart += 4; # skip the length word
             } else {
-                $dirLen = $maxLen;
+                $subLen = $maxLen;
             }
-            $dirLen > $maxLen and $dirLen = $maxLen;
-            if ($dirLen) {
-                my $subTable = GetTagTable($tagInfo->{SubDirectory}->{TagTable});
+            $subLen > $maxLen and $subLen = $maxLen;
+            if ($subLen) {
+                my $subTable = GetTagTable($$tagInfo{SubDirectory}{TagTable});
                 my $subName = $$tagInfo{Name};
-                $subdirInfo{DirStart} = $start;
-                $subdirInfo{DirLen} = $dirLen;
+                $subdirInfo{DirStart} = $subStart + $pos;
+                $subdirInfo{DirLen} = $subLen;
                 $subdirInfo{DirName} = $subName;
                 if ($outfile) {
                     # rewrite this section of the VRD edit information
                     $verbose and print $out "  Rewriting Canon $subName\n";
-                    my $newVal = $exifTool->WriteDirectory(\%subdirInfo, $subTable);
-                    substr($$dataPt, $pos+$start, $dirLen) = $newVal if $newVal;
+                    my $newVal = $et->WriteDirectory(\%subdirInfo, $subTable);
+                    if ($newVal) {
+                        my $sizeDiff = length($newVal) - $subLen;
+                        substr($$dataPt, $pos+$subStart, $subLen) = $newVal;
+                        if ($sizeDiff) {
+                            $subLen = length $newVal;
+                            $recLen += $sizeDiff;
+                            $dirEnd += $sizeDiff;
+                            $dirLen += $sizeDiff;
+                        }
+                    }
                 } else {
-                    $exifTool->VPrint(0, "$$exifTool{INDENT}$subName (SubDirectory) -->\n");
-                    $exifTool->VerboseDump(\$editData,
-                        Start => $start,
-                        Addr  => $dataPos + $pos + $start,
-                        Len   => $dirLen,
+                    $et->VPrint(0, "$$et{INDENT}$subName (SubDirectory) -->\n");
+                    $et->VerboseDump($dataPt,
+                        Start => $pos + $subStart,
+                        Addr  => $dataPos + $pos + $subStart,
+                        Len   => $subLen,
                     );
                     # extract tags from this section of the VRD edit information
-                    $exifTool->ProcessDirectory(\%subdirInfo, $subTable);
+                    $et->ProcessDirectory(\%subdirInfo, $subTable);
                 }
             }
             # next section starts at the end of this one
-            $start += $dirLen;
+            $subStart += $subLen;
+        }
+        if ($outfile and $saveRecLen ne $recLen) {
+            # update record length if necessary
+            Set32u($recLen, $dataPt, $pos - 4)
         }
     }
     if ($outfile) {
-        return undef if $oldChanged == $$exifTool{CHANGED};
+        return undef if $oldChanged == $$et{CHANGED};
         return substr($$dataPt, $$dirInfo{DirStart}, $dirLen);
     }
@@ -1014,5 +1633,5 @@
 sub ProcessIHL($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dataPos = $$dirInfo{DataPos};
@@ -1021,5 +1640,5 @@
     my $dirEnd = $pos + $dirLen;
 
-    $exifTool->VerboseDir('VRD IHL', 0, $dirLen);
+    $et->VerboseDir('VRD IHL', 0, $dirLen);
 
     SetByteOrder('II'); # (make up your mind, Canon!)
@@ -1027,5 +1646,5 @@
         my $hdr = substr($$dataPt, $pos, 48);
         unless ($hdr =~ /^IHL Created Optional Item Data\0\0/) {
-            $exifTool->Warn('Possibly corrupted VRD IHL data');
+            $et->Warn('Possibly corrupted VRD IHL data');
             last;
         }
@@ -1034,9 +1653,9 @@
         my $next = Get32u($dataPt, $pos + 44); # size of complete IHL record
         if ($size > $next or $pos + 48 + $next > $dirEnd) {
-            $exifTool->Warn(sprintf('Bad size for VRD IHL tag 0x%.4x', $tag));
+            $et->Warn(sprintf('Bad size for VRD IHL tag 0x%.4x', $tag));
             last;
         }
         $pos += 48;
-        $exifTool->HandleTag($tagTablePtr, $tag, substr($$dataPt, $pos, $size),
+        $et->HandleTag($tagTablePtr, $tag, substr($$dataPt, $pos, $size),
             DataPt  => $dataPt,
             DataPos => $dataPos,
@@ -1047,6 +1666,6 @@
     }
     return 1;
-}    
-    
+}
+
 #------------------------------------------------------------------------------
 # Process VRD IHL EXIF data
